/*
 * Copyright  2005 Sun Microsystems Inc. All rights reserved. Use is subject to license terms.
 *  
 */

/*
 * Created on Feb 14, 2005
 *
 */
package com.sunlabs.archsim.tests.actionarbiter;



import java.util.Iterator;

import com.sunlabs.archsim.base.hierarchy.CompositeEntity;
import com.sunlabs.archsim.base.simulation.Delay;
import com.sunlabs.archsim.gasp.Action;
import com.sunlabs.archsim.gasp.Function;
import com.sunlabs.archsim.gasp.Terminal;

/**
 * @author ib27688
 *
 */
public class AATSink extends Action {
	
	private int sinkDelay= 10;
	
	private Function out= new ActionFired();
	
	public AATSink(String name, CompositeEntity parent) {
		super(name, parent);
		outputFunctions.put(AATGlobal.ACK_DATA_IN_TERMINAL_NAME, out);
	} // FifoAction
	
	public void setDelay(Delay d) {
		out.setDelay(d);
	}
	
	/** Vacuous function used to acknowldge that the action has fired */ 
	private class ActionFired extends Function {
		
		public ActionFired() {
			super("Vacous");
			functionDelay= new Delay(sinkDelay);
		}
	
		public Object value() {
			Iterator ti= terminals.iterator();
			Terminal t= null;
			boolean done= false;
			while (!done && ti.hasNext()) {
				t= (Terminal)(ti.next());
				if (t.getBaseName() == "dataIn") {
					done= true;
				}
			}
			if (t != null && AATGlobal.sinkDisplayReceived ) {
				director.journal("Sink " + AATSink.this.getName() 
						+ ", id= " + AATSink.this.getID()
						+ ", received " + t.getData());
			}
			return null;
		} // value
	} // AcknowledgeData

	
} // class AATSink
